;*** DIROPEN( (ZP)=DEVICEAME ) : .=FCB

ACEIRPEN = *
   LDA #TRUE
   STA CHECKTAT
   JSR GETISKEVICE
   BCC +
   RTS
+  STA OPENEVICE
   STY OPENAMECAN
   JSR GETFNDCB
   BCC +
   RTS
+  STA LFTABLE,X
   LDA OPENEVICE
   STA DEVTABLE,X
   LDA #0
   STA EOFTABLE,X
   LDA #0
   STA SATABLE,X
   STX OPENCB
   LDX OPENEVICE
   LDA CONFIGUF+0,X
   CMP #4
   BNE +
   JMP RDIRPEN
+  LDA #"$"
   STA STRINGUFFER+0
   LDA #"0"
   STA STRINGUFFER+1
   LDA #0
   STA STRINGUFFER+2
   LDX #2
   JSR DIRPENETAME
   JSR OPENOTAME
   BCC +
   RTS
+  LDX OPENCB
   LDA LFTABLE,X
   TAX
   JSR KERNELHKIN
   JSR KERNELHRIN
   JSR KERNELHRIN
   JSR KERNELLRCHN
   LDA OPENCB
   CLC
   RTS

   DIRPENETAME = *
   LDY OPENEVICE
   LDA CONFIGUF+3,Y
   BMI DIRAMEATE
   LDY OPENAMECAN
   LDA (ZP),Y
   BNE +
   RTS
+  LDX #1

   DIRAMEORMAL = *
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  DEX
   LDA #":"
   CMP STRINGUFFER,X
   BEQ +
   INX
   STA STRINGUFFER,X
+  INX
   LDA #"*"
   STA STRINGUFFER,X
   INX
   LDA #0
   STA STRINGUFFER,X
   RTS

   DIRAMEATE = *
   LDA #"="
   STA STRINGUFFER+1
   LDA #"T"
   STA STRINGUFFER+2
   LDX #3
   LDY OPENAMECAN
   JSR DIRAMEORMAL
   LDA #"="
   STA STRINGUFFER,X
   INX
   LDA #"L"
   STA STRINGUFFER,X
   INX
   LDA #0
   STA STRINGUFFER,X
   RTS

ACEIRLOSE = *
   TAX
   LDA PIDTABLE,X
   CMP ACEROCESS
   BEQ +
   CLC
   RTS
+  LDY DEVTABLE,X
   STX CLOSED
   LDA CONFIGUF+0,Y
   CMP #4
   BEQ +
   LDA CLOSED
   JMP ACELOSE
+  JMP RDIRLOSE

;*** DIRREAD( .=FCB ) : .=EOF, ACEIRENTUFFER=DATA

DIRLOCKS = SYSWORK+0

ACEIREAD = *
   LDY DEVTABLE,X
   LDA CONFIGUF+0,Y
   CMP #4
   BNE +
   JMP RDIREAD
+  LDA LFTABLE,X
   TAX
   JSR KERNELHKIN
   BCC +
   LDA #0
   RTS
   ;** READ THE LINK
+  JSR KERNELHRIN
   STA SYSWORK+4
   JSR KERNELEADST
   AND #$40
   BNE DIRREADOFXIT
   JSR KERNELHRIN
   ORA SYSWORK+4
   BNE +

   DIRREADOFXIT = *
   JSR KERNELLRCHN
   LDX #0
   RTS
   DIRREADRRXIT = *
   STA ERRNO
   JSR KERNELLRCHN
   LDX #0
   SEC
   RTS

   ;** READ THE BLOCK COUNT
+  JSR KERNELHRIN
   STA DIRLOCKS
   STA ACEIRENTYTES+1
   JSR KERNELHRIN
   STA DIRLOCKS+1
   STA ACEIRENTYTES+2
   ASL DIRLOCKS
   ROL DIRLOCKS+1
   LDA #0
   ROL
   STA DIRLOCKS+2
   SEC
   LDA #0
   SBC DIRLOCKS
   STA ACEIRENTYTES+0
   LDA ACEIRENTYTES+1
   SBC DIRLOCKS+1
   STA ACEIRENTYTES+1
   LDA ACEIRENTYTES+2
   SBC DIRLOCKS+2
   STA ACEIRENTYTES+2
   ;** READ THE FILENAME
   LDA #0
   STA ACEIRENTAME
   STA ACEIRENTAMEEN
-  JSR KERNELHRIN
   BCS DIRREADRRXIT
   BIT ST
   BVS DIRREADRRXIT
   CMP #" "
   BEQ -
   CMP #18
   BEQ -
   CMP #$22
   BNE DIRREADXIT
   LDX #0
-  JSR KERNELHRIN
   BCS DIRREADRRXIT
   BIT ST
   BVS DIRREADRRXIT
   CMP #$22
   BEQ +
   STA ACEIRENTAME,X
   INX
   BNE -
+  LDA #0
   STA ACEIRENTAME,X
   STX ACEIRENTAMEEN
-  JSR KERNELHRIN
   CMP #" "
   BEQ -
   ;** READ TYPE AND FLAGS
   LDX #%01100000
   STX ACEIRENTLAGS
   LDX #%10000000
   STX ACEIRENTSAGE
   CMP #"*"
   BNE +
   LDA ACEIRENTLAGS
   ORA #%00001000
   STA ACEIRENTLAGS
   JSR KERNELHRIN
+  LDX #3
   LDY #0
   JMP DIRYPEIRST
-  JSR KERNELHRIN
   DIRYPEIRST = *
   STA ACEIRENTYPE,Y
   INY
   DEX
   BNE -
   LDA #0
   STA ACEIRENTYPE+3
   LDA ACEIRENTYPE
   CMP #"D"
   BNE +
   LDA ACEIRENTLAGS
   ORA #%10010000
   STA ACEIRENTLAGS
   JMP DIRREADXIT
+  CMP #"P"
   BNE DIRREADXIT
   LDA ACEIRENTLAGS
   ORA #%00010000
   STA ACEIRENTLAGS
   JMP DIRREADXIT

   DIRREADXIT = *
   JSR KERNELHRIN
   CMP #0
   BNE +
   JMP DIRREADEALXIT
+  CMP #"<"
   BNE +
   LDA ACEIRENTLAGS
   AND #%11011111
   STA ACEIRENTLAGS
+  LDX #7
   LDA #0
-  STA ACEIRENTATE,X
   DEX
   BPL -
-  JSR KERNELHRIN
   CMP #0
   BEQ DIRREADEALXIT
   CMP #"0"
   BCC -
   CMP #"9"+1
   BCS -

   DIRREADATE = *
   JSR DIRETUMOT
   BCS DIRREADEALXIT
   STA ACEIRENTATE+2
   JSR DIRETUM
   BCS DIRREADEALXIT
   STA ACEIRENTATE+3
   JSR DIRETUM
   BCS DIRREADEALXIT
   STA ACEIRENTATE+1
   LDA CONFIGUF+$86
   STA ACEIRENTATE+0
   JSR DIRETUM
   BCS DIRREADEALXIT
   STA ACEIRENTATE+4
   JSR DIRETUM
   BCS DIRREADEALXIT
   STA ACEIRENTATE+5
   JSR KERNELHRIN
   AND #$FF
   BEQ DIRREADEALXIT
   JSR KERNELHRIN
   AND #$FF
   BEQ DIRREADEALXIT
   CMP #"A"
   BNE DIRREAD

   DIRREAD = *
   LDA ACEIRENTATE+4
   CMP #$12
   BNE +
   LDA #$00
   STA ACEIRENTATE+4
   JMP +

   DIRREAD = *
   LDA ACEIRENTATE+4
   CMP #$12
   BEQ +
   CLC
   SEI
   SED
   ADC #$12
   CLD
   CLI
   STA ACEIRENTATE+4

/  JSR KERNELHRIN
   CMP #0
   BNE -

   DIRREADEALXIT = *
   JSR KERNELLRCHN
   LDX #$FF
   CLC
   RTS

   DIRETUM = *
-  JSR KERNELHRIN
   DIRETUMOT = *
   CMP #0
   BEQ +
   CMP #"0"
   BCC -
   CMP #"9"+1
   BCS -
   ASL
   ASL
   ASL
   ASL
   STA SYSWORK+6
   JSR KERNELHRIN
   CMP #0
   BEQ +
   AND #$0F
   ORA SYSWORK+6
   CLC
+  RTS

;*** FDSWAP( .=CB1, .=CB2 )

ACECBWAP = *
   LDA LFTABLE,X
   PHA
   LDA LFTABLE,Y
   STA LFTABLE,X
   PLA
   STA LFTABLE,Y
   LDA DEVTABLE,X
   PHA
   LDA DEVTABLE,Y
   STA DEVTABLE,X
   PLA
   STA DEVTABLE,Y
   LDA SATABLE,X
   PHA
   LDA SATABLE,Y
   STA SATABLE,X
   PLA
   STA SATABLE,Y
   LDA EOFTABLE,X
   PHA
   LDA EOFTABLE,Y
   STA EOFTABLE,X
   PLA
   STA EOFTABLE,Y
   LDA PIDTABLE,X
   PHA
   LDA PIDTABLE,Y
   STA PIDTABLE,X
   PLA
   STA PIDTABLE,Y
   TXA
   ASL
   ASL
   ASL
   ASL
   TAX
   TYA
   ASL
   ASL
   ASL
   ASL
   TAY
   LDA #16
   STA SYSWORK+15
-  LDA FCBABLE1,X
   PHA
   LDA FCBABLE1,Y
   STA FCBABLE1,X
   PLA
   STA FCBABLE1,Y
   INX
   INY
   DEC SYSWORK+15
   BNE -
   CLC
   RTS

;*** BLOAD( (ZP)=AME, .=DDRESS, (ZW)=IMIT+1 ) : .=ND+1

BLOADDDRESS = SYSWORK
BLOADILENAME = SYSWORK+2
BLOADEVICE = SYSWORK+4

ACELOAD = *
   STA BLOADDDRESS+0
   STY BLOADDDRESS+1
   JSR GETEVICE
   STA BLOADEVICE
   TAX
   CLC
   TYA
   ADC ZP+0
   STA BLOADILENAME+0
   LDA ZP+1
   ADC #0
   STA BLOADILENAME+1
   LDA CONFIGUF+0,X
   CMP #4
   BNE +
   JMP RDLOAD
+  CMP #1
   BEQ +
   LDA #ACERRLLEGALEVICE
   STA ERRNO
   SEC
   RTS
+  LDA CONFIGUF+1,X
   TAX
   LDA #0
   LDY #0
   JSR KERNELETLFS
   LDY #0
-  LDA (BLOADILENAME),Y
   BEQ +
   INY
   BNE -
+  TYA
   LDX BLOADILENAME+0
   LDY BLOADILENAME+1
   JSR KERNELETNAM
   LDA #0
   LDX BLOADDDRESS+0
   LDY BLOADDDRESS+1
   JSR KERNELOAD
   STX BLOADDDRESS+0
   STY BLOADDDRESS+1
   BCC BLOADK
   PHA
   CMP #ACERREVICEOTRESENT
   BEQ +
   LDX BLOADEVICE
   LDA CONFIGUF+0,X
   CMP #1
   BNE +
   TXA
   JSR OPENISKTATUS
+  PLA
-  STA ERRNO
   LDA #0
   LDX #0
   LDY #0
   SEC
   RTS

   BLOADK = *
   LDX BLOADEVICE
   LDA CONFIGUF+0,X
   CMP #1
   BNE +
   TXA
   JSR OPENISKTATUS
   BCS -
+  LDA BLOADDDRESS+0
   LDY BLOADDDRESS+1
   RTS

;*** REMOVE( (ZP)=AME )

REMOVEEVICE = SYSWORK

ACEEMOVE = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STA REMOVEEVICE
   CPX #4
   BNE +
   JMP RDEMOVE
+  LDA #"S"
   STA STRINGUFFER
   LDA #":"
   STA STRINGUFFER+1
   LDX #1
   LDA (ZP),Y
   CMP #"/"
   BEQ +
   LDX #2
/  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  LDA #0
   STA STRINGUFFER,X
   LDA REMOVEEVICE
   JSR CMDCHPEN
   BCS ++
   JSR CMDCHEND
   BCS +
   JSR CHECKISKTATUS
+  PHP
   JSR CMDCHLOSE
   PLP
+  RTS

;*** CDHOME( )

ACEDOME = *
   LDA #<CONFIGUF+$90
   LDY #>CONFIGUF+$90
   STA ZP+0
   STY ZP+1
   ;** FALL THROUGH

;*** CHDIR( (ZP)=IRAME )

CHDIREVICE = SYSWORK+0
CHDIRCAN   = SYSWORK+1
CHDIRAMECAN = SYSWORK+2
CHDIRHARAVE = SYSWORK+3

ACEHIR = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STY CHDIRAMECAN
   STA CHDIREVICE
   CPX #4
   BNE +
   JMP RDHIR
+  LDA #"C"
   STA STRINGUFFER+0
   LDA #"D"
   STA STRINGUFFER+1
   LDX #2
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   CMP #":"
   BEQ +
   INY
   INX
   BNE -
+  LDA #0
   STA STRINGUFFER,X
   CPX #2
   BEQ CHDIRETAME
   LDA #"/"
   CMP STRINGUFFER-1,X
   BEQ +
   STA STRINGUFFER,X
   INX
   LDA #0
   STA STRINGUFFER,X
+  LDA CHDIREVICE
   JSR CMDCHPEN
   BCC +
   RTS
+  JSR CMDCHEND
   BCS CHDIRBORT
   JSR CHECKISKTATUS
   BCS CHDIRBORT

   LDA #"P"
   STA STRINGUFFER+1
   LDX #0
-  LDA STRINGUFFER+2,X
   CMP #"0"
   BCC +
   CMP #"9"+1
   BCS +
   INX
   BNE -
+  CPX #0
   BEQ +
   CMP #"/"
   BNE +
   STA CHDIRHARAVE
   STX CHDIRAMECAN
   LDA #0
   STA STRINGUFFER+2,X
   JSR CMDCHEND
   BCS CHDIRBORT
   LDX CHDIRAMECAN
   LDA CHDIRHARAVE
   STA STRINGUFFER+2,X
   JSR CHECKISKTATUS
   BCS CHDIRBORT
+  JSR CMDCHLOSE
   LDA CHDIREVICE
   STA ACEURRENTEVICE

   CHDIRETAME = *
   LDA CHDIREVICE
   STA ACEURRENTEVICE
   LSR
   LSR
   ORA #$40
   STA ACEURIRAME+0
   LDA #":"
   STA ACEURIRAME+1
   LDX #0
-  LDA STRINGUFFER+2,X
   STA ACEURIRAME+2,X
   BEQ +
   INX
   BNE -
+  LDA ACEURIRAME+1,X
   CMP #":"
   BEQ +
   LDA #":"
   STA ACEURIRAME+2,X
   INX
+  LDA #0
   STA ACEURIRAME+2,X
   CLC
   RTS

   CHDIRBORT = *
   JSR CMDCHLOSE
   SEC
   RTS

;*** DEVINFO( .=CB ) : .=EVYPE(0=CON,1=CHAR,2=DISK), .=OLS, .=OWS

ACEEVNFO = *
   LDA DEVTABLE,X
   TAX
   LDA CONFIGUF+0,X
   CMP #2
   BNE +
   JSR WINSIZE
   TAY
   LDA #0
   RTS

+  LDX #80
   LDY #66
   CMP #1
   BEQ +
   CMP #4
   BEQ +
   LDA #1
   RTS
+  LDA #2
   RTS

;*** UTOA( $0+=VALUE32, (ZP)=BUF, .=MINEN ) : BUF, .=LEN

UTOAIN = SYSWORK+2     ;(4)
UTOACD = SYSWORK+6     ;(5)
UTOALAG = SYSWORK+11   ;(1)
UTOAEN = SYSWORK+12    ;(1)
UTOAOS = SYSWORK+13    ;(1)

ACETOA = *
   CMP #0
   BNE +
   LDA #1
+  CMP #10
   BCC +
   LDA #10
+  STA UTOAEN
   SEC
   LDA #10
   SBC UTOAEN
   STA UTOAEN
   LDY #0
-  LDA 0,X
   STA UTOAIN,Y
   INX
   INY
   CPY #4
   BCC - 
   LDX #4
   LDA #0
-  STA UTOACD,X
   DEX
   BPL -
   STA UTOALAG
   LDY #32
   SEI
   SED

   UTOAEXTIT = *
   ASL UTOAIN+0
   ROL UTOAIN+1
   ROL UTOAIN+2
   ROL UTOAIN+3
   LDX #4
-  LDA UTOACD,X
   ADC UTOACD,X
   STA UTOACD,X
   DEX
   BPL -
   DEY
   BNE UTOAEXTIT
   CLD
   CLI

   LDA #10
   STA UTOAOS
   LDX #0
   LDY #0
-  LDA UTOACD,X
   JSR UTOAUTEX
   INX
   CPX #5
   BCC -
   LDA #0
   STA (ZP),Y
   RTS

   UTOAUTEX = *
   PHA
   LSR
   LSR
   LSR
   LSR
   JSR UTOAUTIGIT
   PLA
   AND #$0F

   UTOAUTIGIT = *
   DEC UTOAOS
   BEQ UTOAORCEIGIT
   CMP UTOALAG
   BNE UTOAORCEIGIT
   DEC UTOAEN
   BMI +
   RTS
+  LDA #$20
   BNE UTOAOKE
   UTOAORCEIGIT = *
   ORA #$30
   STA UTOALAG
   
   UTOAOKE = *
   STA (ZP),Y
   INY
   RTS

;*** DATE( (.)=DATETRING )  FMT::::::::

ACEETATE = *
   STA SYSWORK+$E
   STY SYSWORK+$F
   LDY #3
-  LDA ACEATE,Y
   STA (SYSWORK+$E),Y
   DEY
   BPL -
   LDY #4
   LDA CIA1+$B
   BPL +
   AND #$1F
   SEI
   SED
   CLC
   ADC #$12
   CLD
   CLI
+  CMP #$12
   BNE +
   LDA #$00
+  CMP #$24
   BNE +
   LDA #$12
+  STA (SYSWORK+$E),Y
   INY
   LDA CIA1+$A
   STA (SYSWORK+$E),Y
   INY
   LDA CIA1+$9
   STA (SYSWORK+$E),Y
   INY
   LDA CIA1+$8
   ASL
   ASL
   ASL
   ASL
   ORA ACE
   STA (SYSWORK+$E),Y
   RTS

ACEETATE = *
   STA SYSWORK
   STY SYSWORK+1
   LDY #3
-  LDA (SYSWORK),Y
   STA ACEATE,Y
   DEY
   BPL -
   LDY #4
   LDA (SYSWORK),Y
   CMP #$13
   BCC +
   SEI
   SED
   SEC
   SBC #$12
   CLD
   CLI
   ORA #$80
+  STA CIA1+$B
   INY
   LDA (SYSWORK),Y
   STA CIA1+$A
   INY
   LDA (SYSWORK),Y
   STA CIA1+$9
   INY
   LDA (SYSWORK),Y
   LSR
   LSR
   LSR
   LSR
   STA CIA1+$8
   LDA (SYSWORK),Y
   AND #$07
   STA ACE
   RTS

;*** RENAME( (ZP)=LDAME, (ZW)=EWAME )
;*** DON'T EVEN THINK ABOUT RENAMING FILES OUTSIDE THE CURRENT DIRECTORY

RENAMEEVICE = SYSWORK+0
RENAMECAN   = SYSWORK+1

ACEENAME = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STA RENAMEEVICE
   CPX #4
   BNE +
   JMP RDENAME
+  STY RENAMECAN
   LDA #"R"
   STA STRINGUFFER+0
   LDA #":"
   STA STRINGUFFER+1
   ;** COPY NEW NAME
   LDY #0
   LDX #2
-  LDA (ZW),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  LDA #"="
   STA STRINGUFFER,X
   INX
   ;** COPY OLD NAME
   LDY RENAMECAN
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INX
   INY
   BNE -
+  LDA RENAMEEVICE
   JSR CMDCHPEN
   BCS ++
   JSR CMDCHEND
   BCS +
   JSR CHECKISKTATUS
+  PHP
   JSR CMDCHLOSE
   PLP
+  RTS

;*** MKDIR( (ZP)=AME )

MKDIREVICE = SYSWORK

ACEKDIR = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STA MKDIREVICE
   LDA #"M"
   STA STRINGUFFER+0
   LDA #"D"
   STA STRINGUFFER+1
   LDA #":"
   STA STRINGUFFER+2
   LDX #3
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  LDA MKDIREVICE
   JSR CMDCHPEN
   BCS ++
   JSR CMDCHEND
   BCS +
   JSR CHECKISKTATUS
+  PHP
   JSR CMDCHLOSE
   PLP
+  RTS

;*** RMDIR( (ZP)=AME )

RMDIREVICE = SYSWORK

ACEMDIR = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STA RMDIREVICE
   LDA #"R"
   STA STRINGUFFER+0
   LDA #"D"
   STA STRINGUFFER+1
   LDA #":"
   STA STRINGUFFER+2
   LDX #3
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  LDA RMDIREVICE
   JSR CMDCHPEN
   BCS ++
   JSR CMDCHEND
   BCS +
   JSR CHECKISKTATUS
+  PHP
   JSR CMDCHLOSE
   PLP
+  RTS

;BLANK LINE

