;-128/64 KERNEL YNAMIC EMORY & ROCESS ROUTINES, BY RAIG RUCE.

;*** MEMORY ROUTINES ***

.IF COMPUTER-64
   COMODEUFFER = $200
.IFE
TEMP1 = $8F

BKELECTAM0 = $FF01
REU = $DF00
RL = $DE00
RLEGS = $E0A9
RLXEC = $FE1E

;***STARTUP

INITEMORY = *
.IF COMPUTER-64
   LDX #0
-  LDA COMODETART,X
   STA COMODEUFFER,X
   INX
   CPX #COMODEND-COMODETART
   BCC -
.IFE
   RTS

SHUTDOWNEMORY = *
.IF COMPUTER-64
   LDX #0
   LDA #0
-  STA COMODEUFFER,X
   INX
   CPX #COMODEND-COMODETART
   BNE -
.IFE
   RTS

INTERNANKONFIGS = *
.IF COMPUTER-64
   .BYTE $3F,$7F,$BF,$FF,$BF,$FF,$BF,$FF,$3F
.ELSE
   .BYTE $70,$70
.IFE

INTERNANKROUPS = *
.IF COMPUTER-64
   .BYTE $04,$04,$04,$04,$14,$14,$24,$24,$04
.IFE

;***COMMON CODE

COMODETART = *
.IF COMPUTER-64
.ELSE
   COMODEUFFER = COMODETART
.IFE

COMPOAD = *
   STY TEMP1
   LDY MP+2
.IF COMPUTER-64
   LDA INTERNANKROUPS,Y
   STA $D506
.IFE
   LDA INTERNANKONFIGS,Y
   STA BKELECT
   LDY #0
-  LDA (MP),Y
   STA 0,X
   INX
   INY
   CPY TEMP1
   BCC -
   LDA #BK
   STA BKELECT
   CLC
   RTS

COMPTORE = *
   STY TEMP1
   LDY MP+2
.IF COMPUTER-64
   LDA INTERNANKROUPS,Y
   STA $D506
.IFE
   LDA INTERNANKONFIGS,Y
   STA BKELECT
   LDY #0
-  LDA 0,X
   STA (MP),Y
   INX
   INY
   CPY TEMP1
   BCC -
   LDA #BK
   STA BKELECT
   CLC
   RTS

COMOPYOAM0 = *
   LDX MP+2
.IF COMPUTER-64
   LDA INTERNANKROUPS,X
   STA $D506
   LDA INTERNANKONFIGS,X
   TAX
.ELSE
   LDA INTERNANKONFIGS,X
   STA BKELECT
.IFE
   DEY
   BEQ +
.IF COMPUTER-64
-  STX BKELECT
   LDA (MP),Y
   STA BKELECTAM0
.ELSE
-  LDA (MP),Y
.IFE
   STA (ZP),Y
   DEY
   BNE -
.IF COMPUTER-64
+  STX BKELECT
   LDA (MP),Y
   STA BKELECTAM0
.ELSE
+  LDA (MP),Y
.IFE
   STA (ZP),Y
   LDA #BK
   STA BKELECT
   CLC
   RTS

COMOPYROMAM0 = *
   LDX MP+2
.IF COMPUTER-64
   LDA INTERNANKROUPS,X
   STA $D506
   LDA INTERNANKONFIGS,X
   TAX
.ELSE
   LDA INTERNANKONFIGS,X
   STA BKELECT
.IFE
   DEY
   BEQ +
.IF COMPUTER-64
-  STA BKELECTAM0
   LDA (ZP),Y
   STX BKELECT
.ELSE
-  LDA (ZP),Y
.IFE
   STA (MP),Y
   DEY
   BNE -
.IF COMPUTER-64
+  STA BKELECTAM0
   LDA (ZP),Y
   STX BKELECT
.ELSE
+  LDA (ZP),Y
.IFE
   STA (MP),Y
   LDA #BK
   STA BKELECT
   CLC
   RTS
COMODEND = *

;*** ZPLOAD( [MP]=OURCE, .=PEST, .=ENGTH ) : .=ERR

ACEPOAD = *
   LDA MP+3
   BEQ NULLTRRROR
   CMP #$02
   BCC +
   BNE ZPOAD
   JMP COMPOAD-COMODETART+COMODEUFFER
+  STY REU+7
   LDY #$91

ZEROAGEEUP = *
   LDA MP+2
   STA REU+6
   STX REU+2
   LDA #0
   STA REU+3
   STA REU+8
   LDA MP+0
   STA REU+4
   LDA MP+1
   STA REU+5
.IF COMPUTER-64
   LDA VIC+$30
   LDX #$00
   STX VIC+$30
.IFE
   STY REU+1
.IF COMPUTER-64
   STA VIC+$30
.IFE
   CLC
   RTS

NULLTRRROR = *
   LDA #ACERRULLOINTER
   STA ERRNO
   SEC
   RTS

ZPOAD = *
   LDA #$91
ZEROAGELP = *  ;( .=OPCODE, .=ZPADDR, .=LEN, [MP]=FARTR )
   STA RAMLINKPCODE
   LDA #0
   STY RAMLINKENGTH
   STA RAMLINKENGTH+1
   STX RAMLINKEARTR
   STA RAMLINKEARTR+1
   JMP RAMLINKP

RAMLINKPCODE .BUF 1
RAMLINKENGTH .BUF 2
RAMLINKEARTR .BUF 2

RAMLINKP = *  ;( [MP]=FARTR, RAMLINKEARTR, RAMLINKENGTH, RAMLINKPCODE )
   JSR RLEGS
   LDA RAMLINKPCODE
   STA RL+1
   LDA RAMLINKEARTR
   LDY RAMLINKEARTR+1
   STA RL+2
   STY RL+3
   LDX #0
   LDA MP+3
   CMP #ACEEM
   BEQ +
   LDX #4
+  LDA MP+0
   STA RL+4
   CLC
   LDA ACEAMLINKTART,X
   ADC MP+1
   STA RL+5
   LDA ACEAMLINKTART+1,X
   ADC MP+2
   STA RL+6
   LDA RAMLINKENGTH
   LDY RAMLINKENGTH+1
   STA RL+7
   STY RL+8
   LDA #0
   STA RL+10
   STA RL+16
   JSR RLXEC
   CLC
   RTS

;*** ZPSTORE( .=POURCE, [MP]=EST, .=ENGTH ) : .=ERR

ACEPTORE = *
   LDA MP+3
   BEQ NULLTRRROR
   CMP #$02
   BCC +
   BNE ZPTORE
   JMP COMPTORE-COMODETART+COMODEUFFER
+  STY REU+7
   LDY #$90
   JMP ZEROAGEEUP

ZPTORE = *
   LDA #$90
   JMP ZEROAGELP

;*** FETCH( [MP]=AROURCE, (ZP)=AM0EST, .=ENGTH )

FETCHENGTH     .BUF 2
FETCHAVEOURCE .BUF 1
FETCHAVEEST   .BUF 1

ACEETCH = *
   LDX MP+3
   BEQ FETCHULLTRRROR
   CPX #ACEEMNTERNAL
   BCS +
   LDX #$91
   JMP DOEU
+  BNE FETCH
   CPY #0
   BNE FETCHONG
   TAY
   BNE FETCHAGE
   CLC
   RTS

   FETCHULLTRRROR = *
   JMP NULLTRRROR

   FETCHAGE = *  ;( [MP]=FROM, (ZP)=TO, .=LEN(0=256) )
   LDX MP+2
   CPX #0
   BEQ +
   ;XX DON'T HAVE TO WORRY ABOUT THE 64 HAVING MORE THAN ONE BANK YET
   JMP COMOPYOAM0-COMODETART+COMODEUFFER
.IF COMPUTER-64
+  STX BKELECTAM0
.ELSE
+  LDX #BKAM0
   STX BKELECT
.IFE
   DEY
   BEQ +
-  LDA (MP),Y
   STA (ZP),Y
   DEY
   BNE -
+  LDA (MP),Y
   STA (ZP),Y
   LDA #BK
   STA BKELECT
   CLC
   RTS

   FETCHONG = *
   STA FETCHENGTH
   STY FETCHENGTH+1
   LDA MP+1
   STA FETCHAVEOURCE
   LDA ZP+1
   STA FETCHAVEEST
   LDA FETCHENGTH+1
   BEQ FETCHONGXIT
-  LDY #0
   JSR FETCHAGE
   INC MP+1
   INC ZP+1
   DEC FETCHENGTH+1
   BNE -

   FETCHONGXIT = *
   LDY FETCHENGTH
   BEQ +
   JSR FETCHAGE
+  LDA FETCHAVEOURCE
   STA MP+1
   LDA FETCHAVEEST
   STA ZP+1
   CLC
   RTS

FETCH = *
   LDX #$91
LARGELP = *
   STX RAMLINKPCODE
   STA RAMLINKENGTH+0
   STY RAMLINKENGTH+1
   LDA ZP+0
   LDY ZP+1
   STA RAMLINKEARTR+0
   STY RAMLINKEARTR+1
   JMP RAMLINKP

;*** STASH( (ZP)=AM0OURCE, [MP]=AREST, .=LENGTH )

STASHENGTH     .BUF 2
STASHAVEOURCE .BUF 1
STASHAVEEST   .BUF 1

ACETASH = *
   LDX MP+3
   BEQ STASHULLTRRROR
   CPX #ACEEMNTERNAL
   BCS +
   LDX #$90
   JMP DOEU
+  BNE STASH
   CPY #0
   BNE STASHONG
   TAY
   BNE STASHAGE
   CLC
   RTS

   STASHULLTRRROR = *
   JMP NULLTRRROR

   STASHAGE = *
   LDX MP+2
   CPX #0
   BEQ +
   ;XX DON'T HAVE TO WORRY ABOUT THE 64 HAVING MORE THAN ONE BANK YET
   JMP COMOPYROMAM0-COMODETART+COMODEUFFER
.IF COMPUTER-64
+  STX BKELECTAM0
.ELSE
+  LDX #BKAM0
   STX BKELECT
.IFE
   DEY
   BEQ +
-  LDA (ZP),Y
   STA (MP),Y
   DEY
   BNE -
+  LDA (ZP),Y
   STA (MP),Y
   LDA #BK
   STA BKELECT
   CLC
   RTS

   STASHONG = *
   STA STASHENGTH
   STY STASHENGTH+1
   LDA ZP+1
   STA STASHAVEOURCE
   LDA MP+1
   STA STASHAVEEST
   LDA STASHENGTH+1
   BEQ STASHONGXIT
-  LDY #0
   JSR STASHAGE
   INC MP+1
   INC ZP+1
   DEC STASHENGTH+1
   BNE -

   STASHONGXIT = *
   LDY STASHENGTH
   BEQ +
   LDX MP+2
   JSR STASHAGE
+  LDA STASHAVEOURCE
   STA ZP+1
   LDA STASHAVEEST
   STA MP+1
   CLC
   RTS

STASH = *
   LDX #$90
   JMP LARGELP

;*** RAM0 LOAD/STORE(.) EXPANSION MEMORY [MP] <- -> (ZP) FOR . BYTES

DOEU = *
   STA REU+7
   STY REU+8
   LDA ZP+0
   LDY ZP+1
   STA REU+2
   STY REU+3
   LDA MP+0
   LDY MP+1
   STA REU+4
   STY REU+5
   LDA MP+2
   STA REU+6
   LDY VIC+$30
   LDA #0
   STA VIC+$30
   STX REU+1
   STY VIC+$30
   CLC
   RTS

;*** MEMORY ALLOCATION ROUTINES

FREEMAPANK     .BUF 2
FREEMAPIRTY    .BUF 1
FREEMAPAGE     .BUF 1
SEARCHINAIL   .BUF 8

INITEMORYLLOC = *
   LDX #0
   LDY #0
   STX FREEMAPAGE
   STX FREEMAPIRTY
-  LDA RAM0REEAP,X
   STA FREEMAP,X
   BNE +
   INY
+  INX
   BNE -
   LDA #0
   LDY #ACEEMNTERNAL
   STA FREEMAPANK+0
   STY FREEMAPANK+1
   LDA #$00
   LDX #0
-  STA SEARCHINAIL,X
   INX
   CPX #8
   BCC -
   CLC
   RTS

FREEMAPANKAVE .BUF 2

GETREEMAP = *  ;( .=BANK )
   CMP FREEMAPANK+0
   BNE +
   CPY FREEMAPANK+1
   BNE +
   RTS

   ;** SAVE OLD FREEMAP
+  STA FREEMAPANKAVE+0
   STY FREEMAPANKAVE+1
   LDA FREEMAPIRTY
   BEQ +
   LDA FREEMAPANK+0
   LDY FREEMAPANK+1
   JSR LOCATEANKREEMAP
   JSR SETPREEMAP
   JSR STASH

   ;** LOAD NEW FREEMAP
+  LDA FREEMAPANKAVE+0
   LDY FREEMAPANKAVE+1
   STA FREEMAPANK+0
   STY FREEMAPANK+1
   JSR LOCATEANKREEMAP
   JSR SETPREEMAP
   JSR FETCH
   LDA #0
   STA FREEMAPIRTY
   STA FREEMAPAGE
   RTS

   SETPREEMAP = *  ;() : (ZP)=#FREEMAP, .=#256
   LDA #<FREEMAP
   LDY #>FREEMAP
   STA ZP+0
   STY ZP+1
   LDA #<256
   LDY #>256
   RTS

LOCATEANKREEMAP = *  ;( .=BANK ) : [MP]
   STA MP+2
   STY MP+3
   LDA #<$FF00
   LDX #>$FF00
   STA MP+0
   STX MP+1
   CPY #ACEEMNTERNAL
   BEQ +
   RTS
+  LDA MP+2
   BNE +
   ;** RAM0
   LDA ACEAM0REEMAP+0
   LDY ACEAM0REEMAP+1
-  STA MP+0
   STY MP+1
   RTS
+  CMP #1
   BNE +
   ;** RAM1
   LDA #0
   LDY ACEAM1REEMAP
   JMP -
   ;** EXP.INT.RAM
+  LDA #<$0400
   LDY #>$0400
   JMP -

SEARCHYPETART .BUF 1
SEARCHYPETOP  .BUF 1
SEARCHIZE      .BUF 1
ALLOCROC     .BUF 1
SEARCHYPEMP = *
   .WORD 0,PAGELLOC,PAGELLOCNTERNAL,0,0,0,PAGELLOC,PAGELLOC

ACEAGELLOC = *  ;( .=PAGES, .=STYPE, .=ENDYPE ) : [MP]=FARTR
   PHA
   LDA ACEROCESS
   STA ALLOCROC
   PLA
KERNAGELLOC = *
   STA SEARCHIZE
   CMP #0
   BNE +
   JSR PAGELLOCAIL
   CLC
   RTS
+  CPX #ACEEM
   BCS +
   LDX #ACEEM
+  CPY #ACEEM
   BEQ +
   BCC +
   LDY #ACEEM
+  STX SEARCHYPETART
   STY SEARCHYPETOP
-  LDA SEARCHYPETART
   CMP SEARCHYPETOP
   BEQ +
   BCS PAGELLOCAIL
+  LDX SEARCHYPETART
   LDA SEARCHINAIL,X
   BEQ +
   CMP SEARCHIZE
   BEQ PAGELLOCEXT
   BCC PAGELLOCEXT
+  LDA SEARCHYPETART
   ASL
   TAX
   LDA SEARCHYPEMP+0,X
   STA MP+0
   LDA SEARCHYPEMP+1,X
   BEQ PAGELLOCEXT
   STA MP+1
   JSR PAGELLOCISPATCH
   BCC ++
   LDX SEARCHYPETART
   LDA SEARCHINAIL,X
   BEQ +
   CMP SEARCHIZE
   BCC PAGELLOCEXT
+  LDA SEARCHIZE
   STA SEARCHINAIL,X

   PAGELLOCEXT = *
   INC SEARCHYPETART
   JMP -
+  LDX MP+3
   LDA MP+2
   CMP MINSEDANK,X
   BCS +
   STA MINSEDANK,X
+  CMP MAXSEDANK,X
   BCC +
   STA MAXSEDANK,X
+  CLC
   RTS

   PAGELLOCISPATCH = *
   JMP (MP)

   PAGELLOCAIL = *
   LDA #ACERRNSUFFICIENTEMORY
   STA ERRNO
   LDA #$00
   STA MP+0
   STA MP+1
   STA MP+2
   STA MP+3
   SEC
   RTS

PAGELLOC = *  ;( ) : .=PAGE, FREEMAPANK, .=OK
   LDA #ACEEM
   STA MP+3
   LDA ACEEUUR
   LDX ACEEUTART
   LDY ACEEUANKS
   JSR SEARCHYPE
   STA ACEEUUR
   RTS

PAGELLOCNTERNAL = *
   LDA #ACEEMNTERNAL
   STA MP+3
   LDA ACENTERNALUR
   LDX #$00
   LDY ACENTERNALANKS
   JSR SEARCHYPE
   STA ACENTERNALUR
   RTS

PAGELLOC = *
   LDA #ACEEM
   STA MP+3
   LDA ACEAMLINKEUUR
   LDX ACEEUTART
   LDY ACEAMLINKEUANKS
   JSR SEARCHYPE
   STA ACEAMLINKEUUR
   RTS

PAGELLOC = *
   LDA #ACEEM
   STA MP+3
   LDA ACEAMLINKUR
   LDX #$00
   LDY ACEAMLINKANKS
   JSR SEARCHYPE
   STA ACEAMLINKUR
   RTS

SEARCHURRENT .BUF 1
SEARCHTART   .BUF 1
SEARCHTOP    .BUF 1

SEARCHYPE = *  ;( MP+3=TYPE, .=CURRENT, .=START, .=STOP ):[MP],.,.=CUR,.
   STA SEARCHURRENT
   STA MP+2
   STX SEARCHTART
   STY SEARCHTOP
   CPX SEARCHTOP
   BCC +
   RTS
/  LDA MP+2
   LDY MP+3
   JSR GETREEMAP
   LDY SEARCHIZE
   JSR SEARCHREEMAP
   BCS +
   LDA #0
   STA MP+0
   STX MP+1
   LDA MP+2
   CLC
   RTS
+  INC MP+2
   LDA MP+2
   CMP SEARCHTOP
   BCC +
   LDA SEARCHTART
   STA MP+2
+  LDA MP+2
   CMP SEARCHURRENT
   BNE -
   SEC
   RTS

SEARCHAGES .BUF 1
NEWMAX      .BUF 1

SEARCHREEMAP = *  ;( .=PAGES ) : .=FOUND, .=FIRSTG
   ;** FIRST FREE
   LDX FREEMAPAGE
   LDA FREEMAP,X
   BEQ +
-  INX
   BEQ FREEMAPULL
   LDA FREEMAP,X
   BNE -
   STX FREEMAPAGE
   JMP +
   FREEMAPULL = *
   SEC
   RTS

   ;** SEARCH
+  STY SEARCHAGES
   CPX #0
   BEQ +
   DEX
-  LDY SEARCHAGES
-  INX
   BEQ FREEMAPULL
+  LDA FREEMAP,X
   BNE --
   DEY
   BNE -

   ;** ALLOCATE
   STX NEWMAX
   LDY SEARCHAGES
   LDA ALLOCROC
-  STA FREEMAP,X
   DEX
   DEY
   BNE -
   INX
   CPX FREEMAPAGE
   BNE +
   LDY NEWMAX
   INY
   STY FREEMAPAGE
+  LDA #$FF
   STA FREEMAPIRTY
   SEC
   LDA ACEREEEMORY+1
   SBC SEARCHAGES
   STA ACEREEEMORY+1
   LDA ACEREEEMORY+2
   SBC #0
   STA ACEREEEMORY+2
   BCS +
   DEC ACEREEEMORY+3
+  CLC
   RTS

FREEAGE .BUF 1
FREEEN  .BUF 1

ACEAGEREE = *  ;( [MP]=ARTR, .=PAGES )
   LDX ACEROCESS
   STX ALLOCROC
KERNAGEREE = *
   STA FREEEN
   CMP #0
   BNE +
   JMP PAGEREEXIT
+  LDA MP+3
   CMP #ACEEMULL
   BNE +
   LDA #ACERRULLOINTER
   JMP PAGEREEAIL
+  LDA #ACERRNVALIDREEARMS
   LDX MP+0
   BNE PAGEREEAIL
   LDA MP+1
   STA FREEAGE
   CLC
   ADC FREEEN
   BCC +
   LDA #ACERRNVALIDREEARMS
   JMP PAGEREEAIL
+  LDA MP+2
   LDY MP+3
   JSR GETREEMAP
   LDA ALLOCROC
   LDX FREEAGE
   LDY FREEEN
-  CMP FREEMAP,X
   BEQ +
   LDA #ACERRREEOTWNED
   JMP PAGEREEAIL
+  INX
   DEY
   BNE -
   LDX FREEAGE
   LDY FREEEN
   LDA #$00
-  STA FREEMAP,X
   INX
   DEY
   BNE -
   LDA #$FF
   STA FREEMAPIRTY
   LDA FREEAGE
   CMP FREEMAPAGE
   BCS +
   STA FREEMAPAGE
   ;** ASSUME 2*(MIN-1)+LEN+1 NEW MIN
+  LDX MP+3
   LDA SEARCHINAIL,X
   BEQ ++
   SEC
   SBC #1
   ASL
   BCS +
   SEC
   ADC FREEEN
   BCC ++
+  LDA #0
+  STA SEARCHINAIL,X

   CLC
   LDA ACEREEEMORY+1
   ADC FREEEN
   STA ACEREEEMORY+1
   BCC PAGEREEXIT
   INC ACEREEEMORY+2
   BNE PAGEREEXIT
   INC ACEREEEMORY+3

   PAGEREEXIT = *
   CLC
   RTS

   PAGEREEAIL = *
   STA ERRNO
   SEC
   RTS

RECLAIMEMYPE .BUF 1

RECLAIMROCEMORY = *
   LDX #0
-  LDA MINSEDANK,X
   CMP MAXSEDANK,X
   BEQ +
   BCS ++
+  STX RECLAIMEMYPE
   LDA MINSEDANK,X
   LDY MAXSEDANK,X
   TAX
   LDA RECLAIMEMYPE
   JSR RECLAIMROCYPE
   LDX RECLAIMEMYPE
+  INX
   CPX #ACEEMYPES
   BCC -
   RTS

RPANK  .BUF 2
RPND   .BUF 1

RECLAIMROCYPE = *  ;( .=TYPE, .=STARTANK, .=ENDANK )
   STX RPANK+0
   STA RPANK+1
   STY RPND
-  LDA RPANK+0
   LDY RPANK+1
   CMP RPND
   BEQ +
   BCS ++
+  JSR GETREEMAP
   JSR RECLAIMROCREEMAP
   INC RPANK+0
   BNE -
+  RTS

RECLAIMROCREEMAP = *  ;( ) : .=PAGESEMOVED
   LDY #0
   LDX #0
   LDA ACEROCESS
   JMP +
-  INX
   BEQ ++
+  CMP FREEMAP,X
   BNE -
   LDA #0
   STA FREEMAP,X
   INY
   LDA ACEROCESS
   JMP -
+  CPY #0
   BEQ +
   LDA #0
   STA FREEMAPAGE
   LDX FREEMAPANK+1
   STA SEARCHINAIL,X
   LDA #$FF
   STA FREEMAPIRTY
   TYA
   CLC
   ADC ACEREEEMORY+1
   STA ACEREEEMORY+1
   BCC +
   INC ACEREEEMORY+2
   BNE +
   INC ACEREEEMORY+3
+  CLC
   RTS

MINSEDANK .BUF ACEEMYPES
MAXSEDANK .BUF ACEEMYPES  ;PLUS 1

CLEAREMORYNFO = *
   LDX #ACEEMYPES-1
-  LDA #$FF
   STA MINSEDANK,X
   LDA #$00
   STA MAXSEDANK,X
   DEX
   BPL -
   RTS

;*** PROCESS PRIMITIVES

RECLAIMAVE .BUF 1

RECLAIMPENILES = *
   JSR KERNELLRCHN
   LDX #0
-  LDA LFTABLE,X
   CMP #LFNULL
   BEQ +
   LDA PIDTABLE,X
   CMP ACEROCESS
   BNE +
   STX RECLAIMAVE
   TXA
   JSR CLOSE
   LDX RECLAIMAVE
+  INX
   CPX #FCBOUNT
   BCC -
   RTS

ACEEMTAT = *
   LDY #0
-  LDA ACEREEEMORY,Y
   STA 0,X
   LDA ACEOTALEMORY,Y
   STA 4,X
   INX
   INY
   CPY #4
   BCC -
   LDA ACEROCESS
   CLC
   RTS

EXECRGC .BUF 2
EXECRAME .BUF 44+4
EXECTACKEED .BUF 1
EXECDDR .BUF 2
EXECORK .BUF 2

ACEXEC = *
   STA EXECRGC+0
   STY EXECRGC+1
   ;** LOAD EXECUTABLE
   LDA #<ACEPPDDRESS
   LDY #>ACEPPDDRESS
   BRK
   JMP EXECOMMON

ACEXECUB = *
   STA EXECRGC+0
   STY EXECRGC+1
   LDA #0
   STA STRINGUFFER+0
   LDA #10
   STA EXECTACKEED
   LDA ZP+0
   LDY ZP+1

   EXECOMMON = *
   STA EXECDDR+0
   STY EXECDDR+1
   ;** PUT IN FILENAME
   LDX #$FF
-  INX
   LDA STRINGUFFER,X
   BNE -
   INX
   STX SYSWORK+0
   SEC
   LDA ZW+0
   SBC SYSWORK+0
   STA SYSWORK+0
   LDA ZW+1
   SBC #0
   STA SYSWORK+1
   LDY #0
-  LDA STRINGUFFER,Y
   STA (SYSWORK),Y
   BEQ +
   INY
   BNE -

   ;** SET UP NEW FRAME INFO
+  LDX #1
-  LDA ACERAMETR,X
   STA EXECRAME+0,X
   LDA ACERGC,X
   STA EXECRAME+2,X
   LDA ACERGV,X
   STA EXECRAME+4,X
   DEX
   BPL -
   LDX #3
-  LDA MP,X
   STA EXECRAME+14,X
   LDA #0
   STA EXECRAME+18,X
   LDA #ACEEMULL
   STA EXECRAME+24,X
   DEX
   BPL -
   TSX
   STX EXECRAME+22
   LDA #$00
   STA EXECRAME+23
   LDX #7
-  LDA MINSEDANK,X
   STA EXECRAME+28,X
   LDA MAXSEDANK,X
   STA EXECRAME+36,X
   DEX
   BPL -

   ;** STORE NEW FRAME INFO
   LDA ZW+1
   SBC #0
   STA SYSWORK+1
   SEC
   LDA SYSWORK+0
   SBC #44
   STA SYSWORK+0
   BCS +
   DEC SYSWORK+1
+  LDY #43
-  LDA EXECRAME,Y
   STA (SYSWORK),Y
   DEY
   BPL -

   ;** SET UP GLOBALS FOR NEW PROCESS
   LDX #1
-  LDA SYSWORK+0,X
   STA ACERAMETR,X
   STA ACEEMOP,X
   LDA EXECRGC,X
   STA ACERGC,X
   LDA ZW,X
   STA ACERGV,X
   DEX
   BPL -
   JSR CLEAREMORYNFO

   ;** CALL THE NEW PROGRAM
   INC ACEROCESS
   LDA EXECDDR+0
   LDY EXECDDR+1
   STA ZP+0
   STY ZP+1
   LDA #0
   TAX
   TAY
   PHA
   PLP
   JSR ACENTER
   LDA #0
   LDX #0
   JMP ACEXIT

   ACENTER = *
   JMP (ZP)

EXITODEAVE .BUF 2
EXITRGC     .BUF 2
EXITRGV     .BUF 2

ACEXIT = *
   STA EXITODEAVE+0
   STX EXITODEAVE+1
   LDA ACERAMETR+0
   LDY ACERAMETR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDY #43
-  LDA (SYSWORK),Y
   STA EXECRAME,Y
   DEY
   BPL -
   LDX EXECRAME+22
   TXS
   LDX #1
-  LDA ACERGC,X
   STA EXITRGC,X
   LDA ACERGV,X
   STA EXITRGV,X
   LDA EXECRAME+2,X
   STA ACERGC,X
   LDA EXECRAME+4,X
   STA ACERGV,X
   LDA EXECRAME+0,X
   STA ACEEMOP,X
   STA ACERAMETR,X
   DEX
   BPL -

   JSR RECLAIMPENILES
   JSR RECLAIMROCEMORY
   DEC ACEROCESS
   LDX #7
-  LDA EXECRAME+28,X
   STA MINSEDANK,X
   LDA EXECRAME+36,X
   STA MAXSEDANK,X
   DEX
   BPL -
   ;** RELOAD PREVIOUS PROGRAM IF NECESSARY
   LDA ACERAMETR+0
   LDY ACERAMETR+1
   STA SYSWORK+2
   STY SYSWORK+3
   LDA SYSWORK+3
   CMP ACETACKOP+1
   BCS +
   LDY #44
   LDA (SYSWORK+2),Y
   BEQ +
   LDA ACEROCESS
   BRK
   ;JSR RELOAD_PREVIOUS_PROGRAM

   ;** PREPARE EXIT PARAMETERS
+  LDX #3
-  LDA EXECRAME+14,X
   STA MP,X
   DEX
   BPL -
   LDX #1
-  LDA EXITRGC,X
   STA ZP,X
   LDA EXITRGV,X
   STA ZW,X
   DEX
   BPL -
   LDA EXITODEAVE+0
   LDX EXITODEAVE+1
   LDY #0
   CLC
   RTS

;BLANK LINE AT END

